#!/boot/home/config/bin/python

import getopt
import os
import string
import sys
import time
sys.path.insert(0, 'freeze')

# Import the freeze-private modules

import checkextensions
import modulefinder
import makeconfig
#import makefreeze
import makemakefile
import parsesetup
import bkfile
import thread
import marshal
#import string
#import bkfile

import BApplication
from BWindow import BWindow
from BBitmap import BBitmap
from BTextView import BTextView
from BBox import BBox
from BScrollView import BScrollView
from BTextControl import BTextControl
from BEntry import BEntry
from BMessage import BMessage
from BButton import BButton

from InterfaceKit import *
from AppKit import *

class MainWindow(BWindow):
	def __init__(self, rect, title):
		BWindow.__init__(self, rect, title, B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE|B_NOT_RESIZABLE)
		
		l, t, r, b = self.Bounds()
		
		self.mainview = boxy((l, t, r + 1, b + 1), 'main', '')
		self.AddChild(self.mainview)
		
		self.setup = boxy((l + 7, t + 7, r - 7, t + 140), 'setup', 'Drop Your Python App Here...')
		self.mainview.AddChild(self.setup)
		
		self.listing = boxy((l + 7, t + 150, r - 7, b - 7), 'listing', 'Progress/Output')
		self.mainview.AddChild(self.listing)
		
		l, t, r, b = self.listing.Bounds()
		self.output = texty((l + 5, t + 15, r - 20, b - 5), 'out', (5, 5, r-15, b - 15))
		self.outscroll = scrolly('scroll', self.output, 0, 1)
		self.listing.AddChild(self.outscroll)	
		
		l, t, r, b = self.setup.Bounds()
		self.fname = controlly((l + 5, t + 25, r - 15, t + 35), 'fname', 'File', '', 60.0, BMessage(111))
		self.setup.AddChild(self.fname)
		
		self.fpath = controlly((l + 5, t + 50, r - 15, t + 60), 'fpath', 'Path', '', 60.0, BMessage(122))
		self.setup.AddChild(self.fpath)
		
		self.userfolder = controlly((l + 5, t + 75, r - 15, t + 85), 'upath', 'Dest. Folder', '', 60.0, BMessage(133))
		self.setup.AddChild(self.userfolder)
		
		self.go = BButton((l + 15, t + 100, r - 15, t + 120), 'button', 'Build Binary', BMessage(200), B_FOLLOW_ALL, B_WILL_DRAW)
		self.setup.AddChild(self.go)
		
		#################
						
	
	def MessageReceived(self, msg):
		
		if msg.what == B_SIMPLE_DATA:
			
			MSGd = msg.FindRef('refs')
			MSGe = BEntry(MSGd)
			PATHpre = MSGe.GetPath()
			pathF = PATHpre.Path()
			path, file = os.path.split(pathF)
			self.fpath.SetText(path)
			self.fname.SetText(file)
			
			file = open(pathF)
			fdata = file.readlines()
		
			self.Pimports = []
			self.Bimports = []
			self.imp_defs = []
			self.inc_path = []
			self.defs_list = ['InterfaceKit', 'AppKit', 'StorageKit', 'SupportKit']
			for i in fdata:
				if i[:6] == 'import' or i[:4] == 'from':
					module = i.split()[1]
					if module in self.defs_list:
						self.imp_defs.append(module + '.py')
					elif module[0] == 'B':
						self.Bimports.append(module + 'module.so')
				
						
				elif i[:15] == 'sys.path.insert':
					path = i.split("'")[1]
					self.inc_path.append(path)
					
			self.output.insertText('Bethon modules')
			self.output.insertText(string.join(self.Bimports))
			self.output.insertText('')
			
			self.output.insertText('Included Paths')
			self.output.insertText(string.join(self.inc_path))
			
	
		elif msg.what == 200:
			base_path = self.fpath.Text()
			os.chdir(base_path)
			filename = self.fname.Text()
			dest = self.userfolder.Text()
			biname = filename[:-3]
			
			os.mkdir(dest)
			
			inserter = """sys.path.insert(0, '%s')"""
			
			os.system('touch ' + filename + '2')
			f1 = open(filename)
			f2 = open(filename + '2', 'w')
			count = 1
			for i in f1.readlines():
				if count == 2:
					f2.write('import sys')
					f2.write('\n')
					for y in self.inc_path:
						f2.write(inserter % y)
						f2.write('\n')
				f2.write(i)
				
				count = count + 1
			f1.close()
			f2.close()
			
			self.freeze('-o build', filename + '2')
			
			
			os.chdir(base_path + '/build')
			
			self.output.insertText('\nCompiling...\n')
			self.output.Invalidate()
			
			time.sleep(1)
			
			os.system('make')
			os.system('cp ' + biname + ' ../' + dest + '/' + biname + '.app')
						
			self.output.insertText('Creating package folder...\n')
			self.output.Invalidate()
			os.chdir(base_path)
			for i in self.inc_path:
				os.system('cp -R ' + i + ' ' + dest + '/')
		
			os.chdir(base_path)
			os.chdir(dest)
			os.mkdir('lib')
			os.chdir('lib')
			for i in self.unknowns:
			
				if i[0] == 'B':
					try:
						os.system('cp ' + '/boot/home/config/lib/python2.2/plat-beos5/' + i + 'module.so ' + base_path + '/' + dest + '/lib')
					except:
						pass
				else:
					try:
						os.system('cp ' + '/boot/home/config/lib/python2.2/lib-dynload/' + i + '.so ' + base_path + '/' + dest + '/lib')
					except:
						pass
			for i in self.Pimports:
				try:
					os.system('cp ' + '/boot/home/config/lib/python2.2/' + i + ' ' + base_path + '/' + dest + '/lib')
				except:
					pass
					
			for i in self.imp_defs:
				try:
					os.system('cp ' + '/boot/home/config/lib/python2.2/plat-beos5/' + i + ' ' + base_path + '/' + dest + '/lib')
				except:
					pass
				
				
			os.system('cp /boot/home/config/lib/libpython2.2.so ' + base_path + '/' + dest + '/lib')
			
			os.chdir(base_path)
			os.remove(filename + '2')
			os.chdir(base_path)
			for i in os.listdir('build'):
				os.remove('build/' + i)
			os.rmdir('build')
						
			self.output.insertText('Done!\n')
	
	def QuitRequested(self):
		BApplication.be_app.PostMessage(B_QUIT_REQUESTED)
		return 1
		
	def freeze(self, command, file):
		# overridable context
		prefix = None                       # settable with -p option
		exec_prefix = None                  # settable with -P option
		extensions = []
		exclude = []                        # settable with -x option
		addn_link = []      # settable with -l, but only honored under Windows.
		path = sys.path[:]
		modargs = 0
		debug = 1
		odir = ''
		win = sys.platform[:3] == 'win'
		replace_paths = []                  # settable with -r option
		error_if_any_missing = 0
		
		# default the exclude list for each platform
		
		# modules that are imported by the Python runtime
		implicits = ["site", "exceptions"]
		fail_import = exclude[:]
		# output files
		frozen_c = 'frozen.c'
		config_c = 'config.c'
		target = 'a.out'                    # normally derived from script name
		makefile = 'Makefile'
		subsystem = 'console'

		opts = command.split()
		args = [file]
		#print opts, args
		o = opts[0]
		a = opts[1]
		#print o
		#print o, a
	    
		if o == '-o':
			#print a
			odir = a
        	
        
		
		exec_prefix = sys.exec_prefix
		if not prefix:
			prefix = sys.prefix
	
	    # determine whether -p points to the Python source tree
		ishome = os.path.exists(os.path.join(prefix, 'Python', 'ceval.c'))
	
	    # locations derived from options
		version = sys.version[:3]
		if win:
			extensions_c = 'frozen_extensions.c'
		if ishome:
			self.output.insertText("(Using Python source directory)")
			binlib = exec_prefix
			incldir = os.path.join(prefix, 'Include')
			config_h_dir = exec_prefix
			config_c_in = os.path.join(prefix, 'Modules', 'config.c.in')
			frozenmain_c = os.path.join(prefix, 'Python', 'frozenmain.c')
			makefile_in = os.path.join(exec_prefix, 'Modules', 'Makefile')
			if win:
				frozendllmain_c = os.path.join(exec_prefix, 'Pc\\frozen_dllmain.c')
		else:
			binlib = os.path.join(exec_prefix,'lib', 'python%s' % version, 'config')
			incldir = os.path.join(prefix, 'include', 'python%s' % version)
			config_h_dir = os.path.join(exec_prefix, 'include','python%s' % version)
			config_c_in = os.path.join(binlib, 'config.c.in')
			frozenmain_c = os.path.join(binlib, 'frozenmain.c')
			makefile_in = os.path.join(binlib, 'Makefile')
			frozendllmain_c = os.path.join(binlib, 'frozen_dllmain.c')
		supp_sources = []
		defines = []
		includes = ['-I' + incldir, '-I' + config_h_dir]
	
	    # sanity check of directories and files
		check_dirs = [prefix, exec_prefix, binlib, incldir]
		if not win:
	        # These are not directories on Windows.
			check_dirs = check_dirs + extensions
		for dir in check_dirs:
			if not os.path.exists(dir):
				usage('needed directory %s not found' % dir)
			if not os.path.isdir(dir):
				usage('%s: not a directory' % dir)
		if win:
			files = supp_sources + extensions # extensions are files on Windows.
		else:
			files = [config_c_in, makefile_in] + supp_sources
		for file in supp_sources:
			if not os.path.exists(file):
				usage('needed file %s not found' % file)
			if not os.path.isfile(file):
				usage('%s: not a plain file' % file)
		if not win:
			for dir in extensions:
				setup = os.path.join(dir, 'Setup')
				if not os.path.exists(setup):
					usage('needed file %s not found' % setup)
				if not os.path.isfile(setup):
					usage('%s: not a plain file' % setup)
	
	    # check that enough arguments are passed
		if not args:
			usage('at least one filename argument required')
	
	    # check that file arguments exist
		for arg in args:
			if arg == '-m':
				break
	        # if user specified -m on the command line before _any_
	        # file names, then nothing should be checked (as the
	        # very first file should be a module name)
			if modargs:
				break
			if not os.path.exists(arg):
				self.output.insertText(arg)
				usage('argument %s not found' % arg)
			if not os.path.isfile(arg):
				usage('%s: not a plain file' % arg)
	
	    # process non-option arguments
		scriptfile = args[0]
		modules = args[1:]
		
		# derive target name from script name
		base = os.path.basename(scriptfile)
		base, ext = os.path.splitext(base)
		if base:
			if base != scriptfile:
				target = base
		else:
			target = base + '.bin'
	
	    # handle -o option
		base_frozen_c = frozen_c
		base_config_c = config_c
		base_target = target
		if odir and not os.path.isdir(odir):
			try:
				os.mkdir(odir)
				self.output.insertText("Created output directory" + odir)
			except os.error, msg:
				usage('%s: mkdir failed (%s)' % (odir, str(msg)))
		base = ''
		if odir:
			base = os.path.join(odir, '')
			frozen_c = os.path.join(odir, frozen_c)
			config_c = os.path.join(odir, config_c)
			target = os.path.join(odir, target)
			makefile = os.path.join(odir, makefile)
			if win: extensions_c = os.path.join(odir, extensions_c)
	
	    # Handle special entry point requirements
	    # (on Windows, some frozen programs do not use __main__, but
	    # import the module directly.  Eg, DLLs, Services, etc
		custom_entry_point = None  # Currently only used on Windows
		python_entry_is_main = 1   # Is the entry point called __main__?
		# handle -s option on Windows
		if win:
			import winmakemakefile
			try:
					custom_entry_point, python_entry_is_main = \
					winmakemakefile.get_custom_entry_point(subsystem)
			except ValueError, why:
				usage(why)
	            
	
	    # Actual work starts here...
	
	    # collect all modules of the program
		dir = os.path.dirname(scriptfile)
		path[0] = dir
		mf = modulefinder.ModuleFinder(path, debug, exclude, replace_paths)
		
		if win and subsystem=='service':
	        # If a Windows service, then add the "built-in" module.
			mod = mf.add_module("servicemanager")
			mod.__file__="dummy.pyd" # really built-in to the resulting EXE
	
		for mod in implicits:
			mf.import_hook(mod)
		for mod in modules:
			if mod == '-m':
				modargs = 1
				continue
			if modargs:
				if mod[-2:] == '.*':
					mf.import_hook(mod[:-2], None, ["*"])
				else:
					mf.import_hook(mod)
			else:
				mf.load_file(mod)
	
	    # Add the main script as either __main__, or the actual module name.
		if python_entry_is_main:
			mf.run_script(scriptfile)
		else:
			mf.load_file(scriptfile)
	
		if debug > 0:
			mf.report()
			print
		dict = mf.modules
	
		if error_if_any_missing:
			missing = mf.any_missing()
			if missing:
				sys.exit("There are some missing modules: %r" % missing)
	
	    # generate output for frozen modules
		files = self.makefreeze(base, dict, debug, custom_entry_point,fail_import)
	
	    # look for unfrozen modules (builtin and of unknown origin)
		builtins = []
		unknown = []
		mods = dict.keys()
		mods.sort()
		for mod in mods:
			if dict[mod].__code__:
				continue
			if not dict[mod].__file__:
				builtins.append(mod)
			else:
				unknown.append(mod)
	
	    # search for unknown modules in extensions directories (not on Windows)
		addfiles = []
		frozen_extensions = [] # Windows list of modules.
		if unknown or (not win and builtins):
			if not win:
				addfiles, addmods = checkextensions.checkextensions(unknown+builtins, extensions)
				for mod in addmods:
					if mod in unknown:
						unknown.remove(mod)
						builtins.append(mod)
			else:
				# Do the windows thang...
				import checkextensions_win32
				# Get a list of CExtension instances, each describing a module 
				# (including its source files)
				frozen_extensions = checkextensions_win32.checkextensions(unknown, extensions, prefix)
				for mod in frozen_extensions:
					unknown.remove(mod.name)
	
	    # report unknown modules
		if unknown:
			sys.stderr.write('Warning: unknown modules remain: %s\n' % string.join(unknown))
		
		self.unknowns = unknown      	
	    # generate config.c and Makefile
		builtins.sort()
		infp = open(config_c_in)
		outfp = bkfile.open(config_c, 'w')
		try:
			makeconfig.makeconfig(infp, outfp, builtins)
		finally:
			outfp.close()
		infp.close()
	
		cflags = ['$(OPT)']
		cppflags = defines + includes
		libs = [os.path.join(binlib, 'libpython$(VERSION).a')]
		
		somevars = {}
		if os.path.exists(makefile_in):
			makevars = parsesetup.getmakevars(makefile_in)
		for key in makevars.keys():
			somevars[key] = makevars[key]
	
		somevars['CFLAGS'] = string.join(cflags) # override
		somevars['CPPFLAGS'] = string.join(cppflags) # override
		files = ['$(OPT)', '$(LDFLAGS)', base_config_c, base_frozen_c] + files + supp_sources +  addfiles + libs + ['$(MODLIBS)', '$(LIBS)', '$(SYSLIBS)']
	
		outfp = bkfile.open(makefile, 'w')
		try:
			makemakefile.makemakefile(outfp, somevars, files, base_target)
		finally:
			outfp.close()
	
	    # Done!
	    
	def makefreeze(self, base, dict, debug=0, entry_point=None, fail_import=()):
		header = """
			#include "Python.h"

			static struct _frozen _PyImport_FrozenModules[] = {
			"""
		trailer = """\
			{0, 0, 0} /* sentinel */
			};
			"""

		default_entry_point = """
			int
			main(argc, argv)
			int argc;
			char **argv;
			{
			extern int Py_FrozenMain(int, char **);
			""" + ((not __debug__ and """
			Py_OptimizeFlag++;
			""") or "")  + """
			PyImport_FrozenModules = _PyImport_FrozenModules;
			return Py_FrozenMain(argc, argv);
			}

			"""
	
		if entry_point is None: entry_point = default_entry_point
		done = []
		files = []
		mods = dict.keys()
		mods.sort()
		for mod in mods:
			m = dict[mod]
			mangled = string.join(string.split(mod, "."), "__")
			if m.__code__:
				file = 'M_' + mangled + '.c'
				outfp = bkfile.open(base + file, 'w')
				files.append(file)
				if debug:
					self.output.insertText("freezing " + mod + "...")
				str = marshal.dumps(m.__code__)
				size = len(str)
				if m.__path__:
                # Indicate package by negative size
					size = -size
				done.append((mod, mangled, size))
				self.writecode(outfp, mangled, str)
				outfp.close()
		if debug:
			self.output.insertText("generating table of frozen modules")
		outfp = bkfile.open(base + 'frozen.c', 'w')
		for mod, mangled, size in done:
			outfp.write('extern unsigned char M_%s[];\n' % mangled)
		outfp.write(header)
		for mod, mangled, size in done:
			outfp.write('\t{"%s", M_%s, %d},\n' % (mod, mangled, size))
		outfp.write('\n')
		for mod in fail_import:
			outfp.write('\t{"%s", NULL, 0},\n' % (mod,))
		outfp.write(trailer)
		outfp.write(entry_point)
		outfp.close()
		return files


	def writecode(self, outfp, mod, str):
		outfp.write('unsigned char M_%s[] = {' % mod)
		for i in range(0, len(str), 16):
			outfp.write('\n\t')
			for c in str[i:i+16]:
				outfp.write('%d,' % ord(c))
		outfp.write('\n};\n')
	    
class controlly(BTextControl):
	def __init__(self, rect, name, label, info, divider, MSG):
		BTextControl.__init__(self, rect, name, label, info, BMessage(MSG), B_FOLLOW_TOP|B_NAVIGABLE)				
		self.SetDivider(divider)

class scrolly(BScrollView):
	def __init__(self, name, view, hor=1, ver=1):
		BScrollView.__init__(self, name, view, B_FOLLOW_ALL_SIDES, B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW|B_FRAME_EVENTS, hor, ver, B_FANCY_BORDER)
		    
class texty(BTextView):
	def __init__(self, rect, name, rect2):
		BTextView.__init__(self, rect, name , rect2, B_FOLLOW_TOP_BOTTOM|B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW|B_NAVIGABLE)

	def insertText(self, text):
		self.Insert(text + '\n')
		
		cl = self.CurrentLine()
		cll = self.OffsetAt(cl)
		self.ScrollToOffset(cll)	

class boxy(BBox):
	def __init__(self, frame, name, label):
		BBox.__init__(self, frame, name, B_FOLLOW_ALL_SIDES, B_FULL_UPDATE_ON_RESIZE|B_FRAME_EVENTS|B_WILL_DRAW|B_FANCY_BORDER)
		self.SetLabel(label)		

class MainApp(BApplication.BApplication):
	def __init__(self, sig, rect, title):
		BApplication.BApplication.__init__(self, sig)
		self.rect = rect
		self.title = title
		
	def ReadyToRun(self):
		window = MainWindow(self.rect, self.title)
		window.Show()

Version = '0.9'
AppName = """FreedomFreeze %s - Pythonic Binarification""" % Version
Creator = 'Cube-neww'
WindowSize = (50.0, 50.0, 400.0, 450.0)

# Start the App	
ThisApp = MainApp("application/x-vnd." + Creator + '-' + AppName, WindowSize, AppName)
ThisApp.Run()